﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace LongTextColumnPOC
{
    public class DataContextProxy : DependencyObject
    {
        public object ProxiedObject
        {
            get { return (object)GetValue(ProxiedObjectProperty); }
            set { SetValue(ProxiedObjectProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ProxiedObject.    
        //   This enables animation, styling, binding, etc...   
        public static readonly DependencyProperty ProxiedObjectProperty =
            DependencyProperty.Register("ProxiedObject", typeof(object),
                                         typeof(DataContextProxy), null);

    }



    public class BindingProxy : Freezable
    {
        #region Overrides of Freezable

        protected override Freezable CreateInstanceCore()
        {
            return new BindingProxy();
        }

        #endregion

        public object Data
        {
            get { return (object)GetValue(DataProperty); }
            set { SetValue(DataProperty, value); }
        }

        // Using a DependencyProperty as the backing store for Data.  
        // This enables animation, styling, binding, etc...
        public static readonly DependencyProperty DataProperty =
            DependencyProperty.Register("Data", typeof(object),
                typeof(BindingProxy), new UIPropertyMetadata(null));
    }
}
