﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Controls.Grids;

namespace LongTextColumnPOC
{
    /// <summary>
    /// Interaction logic for LongTextDialog.xaml
    /// </summary>
    public partial class LongTextDialog : Window
    {
        public LongTextDialog()
        {
            InitializeComponent();
            DependencyPropertyDescriptor readOnlyDescriptor = DependencyPropertyDescriptor.FromProperty(IsLongTextReadOnlyProperty, typeof(XamGrid));
            if (readOnlyDescriptor != null)
            {
                readOnlyDescriptor.AddValueChanged(this, OnIsLongTextReadOnlyChanged);
            }
        }

        private void OnIsLongTextReadOnlyChanged(object sender, EventArgs args)
        {
            if (IsLongTextReadOnly)
            {
                CancelButton.Visibility = Visibility.Collapsed;
            }
            else
            {
                CancelButton.Visibility = Visibility.Visible;
            }
        }

        public readonly static DependencyProperty FieldNameProperty =
           DependencyProperty.Register("FieldName", typeof(string), typeof(LongTextDialog));

        public string FieldName
        {
            get { return (string)GetValue(FieldNameProperty); }
            set
            {
                SetValue(FieldNameProperty, value);
                Title = value + " Text Editor";
            }
        }

        public readonly static DependencyProperty LongTextValueProperty =
       DependencyProperty.Register("LongTextValue", typeof(string), typeof(LongTextDialog));

        public string LongTextValue
        {
            get { return (string)GetValue(LongTextValueProperty); }
            set
            {
                SetValue(LongTextValueProperty, value);
            }
        }

        public readonly static DependencyProperty IsLongTextReadOnlyProperty =
      DependencyProperty.Register("IsLongTextReadOnly", typeof(bool), typeof(LongTextDialog));

        public bool IsLongTextReadOnly
        {
            get { return (bool)GetValue(IsLongTextReadOnlyProperty); }
            set
            {
                SetValue(IsLongTextReadOnlyProperty, value);
            }
        }

        private void OkButtonClick(object sender, RoutedEventArgs e)
        {
            DialogResult = true;
        }

        private void CancelButtonClick(object sender, RoutedEventArgs e)
        {
            DialogResult = false;
        }
    }
}
