﻿using System.ComponentModel;
using System.Windows;
using System.Windows.Input;
using GalaSoft.MvvmLight;
using GalaSoft.MvvmLight.Command;

namespace LongTextColumnPOC
{
   public class MainWindowViewModel : ViewModelBase
   {
       public MainWindowViewModel()
       {
           TestItemSource = new BindingList<TestModel>
           {
               new TestModel
               {
                   Id = "1",
                   Description = "One"
               },
               new TestModel
               {
                   Id = "2",
                   Description = "Two"
               },
               new TestModel
               {
                   Id = "3",
                   Description = "Three"
               }
           };

           Command = new RelayCommand<TestModel>(OnDoubleClick);
       }

       private bool _isReadOnly;
       public bool IsReadOnly
       {
           get
           {
               return _isReadOnly;
           }

           set
           {
               _isReadOnly = value;
               RaisePropertyChanged("IsReadOnly");
           }
       }

       public ICommand Command { get; protected set; }

       protected void OnDoubleClick(TestModel model)
       {
           var item = SelectedItem;

       }

       public TestModel _selectedItem;
       public TestModel SelectedItem
       {
           get { return _selectedItem; }
           set
           {
               _selectedItem = value;
               RaisePropertyChanged("SelectedItem");
           }
       }

       private BindingList<TestModel> _testItemSource = new BindingList<TestModel>();
       public BindingList<TestModel> TestItemSource
       {
           get
           {
               return _testItemSource;
           }

           set
           {
               _testItemSource = value;
               RaisePropertyChanged("TestItemSource");
           }
       }

    

     
       public bool IsEditable
       {
           get
           {
               
               return true;
           }
       }


   }
   
   public class TestModel
   {
       public string Id { get; set; }
       public string Description { get; set; }

       public bool IsEditable
       {
           get
           {
               if (Id == "1") return false;
               return true;
           }
       }
   }
}
